## ros-lunar-rc-visard-driver 2.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

# Don't set PROJECT_VERSION to empty string when no VERSION is given to project() command.
if(POLICY CMP0048)
cmake_policy(SET CMP0048 OLD)
endif()

project(rc_visard_driver)
include(cmake/project_version.cmake)

# - Configuration for code optimization -

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RELEASE CACHE STRING "Build type: DEBUG or RELEASE" FORCE)
endif ()

# - Standard definitions -

add_definitions(-Wall)
add_definitions(-std=c++11)
add_definitions(-Wno-unknown-pragmas)

# add a target to generate API documentation with Doxygen

add_subdirectory(doc)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  nodelet
  roscpp
  std_srvs
  sensor_msgs
  image_transport
  dynamic_reconfigure
  geometry_msgs
  tf
  nav_msgs
  visualization_msgs
  message_generation
)

## Generate services in the 'srv' folder
add_service_files(
    FILES
    GetTrajectory.srv
)

## Generate added messages and services with any dependencies listed here
generate_messages(
        DEPENDENCIES
        nav_msgs
)


## System dependencies are found with CMake's conventions
find_package(RC_GENICAM_API 2.0.0 REQUIRED)
find_package(RC_DYNAMICS_API REQUIRED)

#########################################
## Definitions for dynamic reconfigure ##
#########################################

generate_dynamic_reconfigure_options(cfg/rc_visard_driver.cfg)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
#  INCLUDE_DIRS include
#  LIBRARIES rc_stereocamera
  CATKIN_DEPENDS nodelet roscpp sensor_msgs geometry_msgs std_srvs nav_msgs
#  DEPENDS
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
  ${catkin_INCLUDE_DIRS}
  ${RC_GENICAM_API_INCLUDE_DIRS}
  ${RC_DYNAMICS_API_INCLUDE_DIRS}
)

add_subdirectory(src)


#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark other files for installation (e.g. launch and bag files, etc.)
install(FILES
        rc_visard_driver_nodelet.xml
        README.md
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
        )
install(DIRECTORY config DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

######################################
## Define information for packaging ##
######################################
# optionally specify dependencies of the debian package here (comma separated!)
set(CPACK_DEBIAN_PACKAGE_DEPENDS "rc-genicam-api (>= 2.0.0) | ros-$ENV{ROS_DISTRO}-rc-genicam-api (>= 2.0.0), rc-dynamics-api | ros-$ENV{ROS_DISTRO}-rc-dynamics-api, ros-$ENV{ROS_DISTRO}-image-pipeline, ros-$ENV{ROS_DISTRO}-tf")

include(cmake/package_debian.cmake)

=== src/CMakeLists.txt ===

set(SRC
    device_nodelet.cc
    protobuf2ros_stream.cc
    ThreadedStream.cc
    publishers/camera_info_publisher.cc
    publishers/image_publisher.cc
    publishers/disparity_publisher.cc
    publishers/disparity_color_publisher.cc
    publishers/depth_publisher.cc
    publishers/confidence_publisher.cc
    publishers/error_disparity_publisher.cc
    publishers/error_depth_publisher.cc
    publishers/points2_publisher.cc
    publishers/protobuf2ros_publisher.cc
    publishers/protobuf2ros_conversions.cc
    publishers/genicam2ros_publisher.h)

# build and install the nodelet

link_directories(${RC_GENICAM_API_LIBRARY_DIRS})

add_library(rc_visard_driver_nodelet ${SRC})

target_link_libraries(rc_visard_driver_nodelet ${catkin_LIBRARIES})
target_link_libraries(rc_visard_driver_nodelet ${RC_GENICAM_API_LIBRARIES})
target_link_libraries(rc_visard_driver_nodelet ${RC_DYNAMICS_API_LIBRARIES})

add_executable(rc_visard_driver device_node.cc)
target_link_libraries(rc_visard_driver ${catkin_LIBRARIES})

install(TARGETS rc_visard_driver rc_visard_driver_nodelet
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
        ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

add_dependencies(rc_visard_driver_nodelet rc_visard_driver_gencfg)

=== debian/changelog ===
ros-lunar-rc-visard-driver (2.5.0-0xenial) xenial; urgency=high

  * add parameter for max number of reconnections
  * fix: enable driver to try to recover even if the very first time no connection worked out
  * add diagnostics
  * fix reporting of package size
  * Fixed hanging image streams after restart of sensor
  * Support for rc_visard firmware v1.5.0 additions (require StereoPlus license)
    * quality full
    * advanced smoothing
  * improved driver's auto-connect behavior
  * also reapply dynamic_reconfigure params after recovery
  * fix projection matrix in published right CameraInfo

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 04 Feb 2019 23:00:00 -0000

ros-lunar-rc-visard-driver (2.4.2-0xenial) xenial; urgency=high



 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 28 Oct 2018 23:00:00 -0000

ros-lunar-rc-visard-driver (2.4.1-0xenial) xenial; urgency=high

  * Fixed link error if rc_genicam_api is not installed in a standard directory
  * docker images: upgrade packages first

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 28 Oct 2018 23:00:00 -0000

ros-lunar-rc-visard-driver (2.4.0-0xenial) xenial; urgency=high

  * added depth_acquisition_mode parameter
  * added depth_acquisition_trigger service call
  * Reduced latency for passing changes of dynamic parameters and topic discriptions to GenICam
  * Fixed using wrong disparity range in disparity color publisher
  * now depends on rc_genicam_api >= 2.0.0

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 15 Oct 2018 22:00:00 -0000

ros-lunar-rc-visard-driver (2.3.0-0xenial) xenial; urgency=high

  * read params from parameter server before falling back to current device params
  * New image topics ...out1_low and ...out1_high are offered if iocontrol module is available

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 20 Aug 2018 22:00:00 -0000

ros-lunar-rc-visard-driver (2.2.1-0xenial) xenial; urgency=high

  * Changed to component intensity before changing pixel format for supporting color rc_visards with version >= 1.3.0

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 04 Jul 2018 22:00:00 -0000

ros-lunar-rc-visard-driver (2.2.0-0xenial) xenial; urgency=high

  * fix out1_mode/out2_mode description and default
  * change/add service calls for onboard SLAM module:
    - rename dynamics_reset_slam to slam_reset
    - rename get_trajectory to slam_get_trajectory
    - add slam_save_map, slam_load_map and slam_remove_map
  * install Rviz example config file

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 02 Jul 2018 22:00:00 -0000

ros-lunar-rc-visard-driver (2.1.1-0xenial) xenial; urgency=high

  * Adjusting disparity range to content of disparity image for colored disparity visualization
  * Added debug message if left and disparity images cannot be synchronized for creating point clouds
  * Implemented parameters for IO control and relaxed time synchronization in case of exposure alternate mode

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 14 Jun 2018 22:00:00 -0000

ros-lunar-rc-visard-driver (2.1.0-0xenial) xenial; urgency=high

  * add ptp_enabled dynamic_reconfigure parameter (to enable PrecisionTimeProtocol Slave on rc_visard)
  * add reset service for SLAM
  * README updates
  * use 'rc_visard' as default device name (works with one rc_visard with factory settings connected)

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 22 Apr 2018 22:00:00 -0000

ros-lunar-rc-visard-driver (2.0.0-0xenial) xenial; urgency=high

  * rc_genicam_api and rc_dynamics_api as dependency instead of submodule
  * don't reset if datastreams time out
  * added get_trajectory service
  * Use new statemachine interface
    Return codes are now strings.
  * Add services start_slam, restart_slam and stop_slam
  * Publishing dynamics as odometry message
  * visualizing dynamics message
    - angular velocity, linear accelerarion published as marker
    for visualization
    - cam2imu-transform is published with re-created timestamp
  * Contributors: Christian Emmerich, Felix Endres, Felix Ruess, Heiko Hirschmueller

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 26 Feb 2018 23:00:00 -0000

ros-lunar-rc-visard-driver (1.2.1-0xenial) xenial; urgency=high

  * use rc_genicam_api as dependency
    instead of including as submodule
    also remove launchfile, as the device is a required parameter anyway...
  * Contributors: Felix Ruess

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 25 Feb 2018 23:00:00 -0000

ros-lunar-rc-visard-driver (1.2.0-0xenial) xenial; urgency=high

  * Setting default of median to 1 instead of 0, which also means off
  * install rc_visard_driver node in package lib dir, so start it with rosrun rc_visard_driver rc_visard_driver

 -- Felix Ruess <felix.ruess@roboception.de>  Sat, 10 Feb 2018 23:00:00 -0000

ros-lunar-rc-visard-driver (1.1.3-0xenial) xenial; urgency=high

  * Added possibility to start as ROS node alternatively to nodelet
  * Printing shutdown information to stdout, since ROS log messages just before exit disappear

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 12 Apr 2017 22:00:00 -0000

ros-lunar-rc-visard-driver (1.1.2-0xenial) xenial; urgency=high

  * The module reconnects to the GigE Vision server in case of errors
  * Added reporting enabled componets and missing images

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 10 Apr 2017 22:00:00 -0000

ros-lunar-rc-visard-driver (1.1.0-0xenial) xenial; urgency=high

  * Implemented setting camera framerate via dynamic reconfigure
  * Implementation of dynamic reconfigure parameters for controlling the depth image

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 09 Apr 2017 22:00:00 -0000

ros-lunar-rc-visard-driver (1.0.1-0xenial) xenial; urgency=high

  * Focal length of disparity image now relates to the size of the disparity image
  * Use color for point cloud if color images are available

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 15 Mar 2017 23:00:00 -0000



=== debian/control ===
Source: ros-lunar-rc-visard-driver
Section: misc
Priority: extra
Maintainer: Felix Ruess <felix.ruess@roboception.de>
Build-Depends: debhelper (>= 9.0.0), curl, libcurl4-openssl-dev, libprotobuf-dev, libprotoc-dev, protobuf-compiler, ros-lunar-catkin, ros-lunar-diagnostic-updater, ros-lunar-dynamic-reconfigure, ros-lunar-geometry-msgs, ros-lunar-image-transport, ros-lunar-message-generation, ros-lunar-nav-msgs, ros-lunar-nodelet, ros-lunar-rc-dynamics-api (>= 0.7), ros-lunar-rc-genicam-api (>= 1.3.12), ros-lunar-roscpp, ros-lunar-sensor-msgs, ros-lunar-std-srvs, ros-lunar-stereo-msgs, ros-lunar-tf, ros-lunar-visualization-msgs
Homepage: http://wiki.ros.org/rc_visard_driver
Standards-Version: 3.9.2

Package: ros-lunar-rc-visard-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, curl, libcurl4-openssl-dev, libprotobuf9v5, ros-lunar-diagnostic-updater, ros-lunar-dynamic-reconfigure, ros-lunar-geometry-msgs, ros-lunar-image-transport, ros-lunar-message-runtime, ros-lunar-nav-msgs, ros-lunar-nodelet, ros-lunar-rc-dynamics-api (>= 0.7), ros-lunar-rc-genicam-api (>= 1.3.12), ros-lunar-roscpp, ros-lunar-sensor-msgs, ros-lunar-std-srvs, ros-lunar-stereo-msgs, ros-lunar-tf, ros-lunar-visualization-msgs
Description: The rc_visard_driver provides data from a Roboception rc_visard 3D sensor on several ROS topics.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-rc-visard-driver//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
